:: Last updated: 2011/09/08
@echo OFF

:: Variables
set ROOT_DIR="%CD%"
set QUICKBMS_EXE="%CD%\Tools\quickbms\quickbms.exe"
set QUICKBMS_SCRIPT="%CD%\Tools\quickbms\dragonnest.bms"
set FILTERER="%CD%\Tools\DNCostumeRenamer\DNCostumeFilterer.jar"
set RESOURCES_DIR_NA="%CD%\Resources-NA"
set RESOURCES_DIR_CN="%CD%\Resources-CN"
set RESOURCES_DIR="%CD%\Resources"
set MODS_DIR=%CD%\Mods\Resources-cn
set PAKPACK_EXE="%CD%\Tools\pakpack\pakpack.exe"
set QUICKBMS_FILTER_PARTS_DDS="*resource\char\player\*\parts\*.dds"
set QUICKBMS_FILTER_PARTS_MSH="*resource\char\player\*\parts\*.msh"
set QUICKBMS_FILTER_CASHS_DDS="*resource\item\cash_item\*.dds"
set QUICKBMS_FILTER_CASHS_MSH="*resource\item\cash_item\*.msh"
set QUICKBMS_FILTER_WEAPS_DDS="*resource\weapon\*.dds"
set QUICKBMS_FILTER_WEAPS_MSH="*resource\weapon\*.msh"
set DRAGON_NEST_DIR=..
set RESOURCE_FILES_NA=Resource00.pak Resource01.pak Resource02.pak Resource03.pak Resource04.pak
set RESOURCE_FILES_CN=Resource00-cn.pak Resource01-cn.pak Resource02-cn.pak Resource03-cn.pak Resource04-cn.pak
set TMP_DIR=%CD%\tmp

:: Make the output directory
mkdir %RESOURCES_DIR_NA% > nul 2>&1
mkdir %RESOURCES_DIR_CN% > nul 2>&1
mkdir %RESOURCES_DIR% > nul 2>&1
mkdir "%MODS_DIR%" > nul 2>&1
mkdir "%TMP_DIR%" > nul 2>&1

:: Extract each resource pack
for %%f in (%RESOURCE_FILES_NA%) do (
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_PARTS_DDS% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_NA%
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_PARTS_MSH% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_NA%
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_CASHS_DDS% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_NA%
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_CASHS_MSH% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_NA%
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_WEAPS_DDS% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_NA%
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_WEAPS_MSH% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_NA%
)
for %%f in (%RESOURCE_FILES_CN%) do (
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_PARTS_DDS% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_CN%
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_PARTS_MSH% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_CN%
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_CASHS_DDS% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_CN%
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_CASHS_MSH% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_CN%
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_WEAPS_DDS% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_CN%
	%QUICKBMS_EXE% -o -f %QUICKBMS_FILTER_WEAPS_MSH% %QUICKBMS_SCRIPT% "%DRAGON_NEST_DIR%\%%f" %RESOURCES_DIR_CN%
)

:: Diff folders
java -jar %FILTERER% %RESOURCES_DIR_NA% %RESOURCES_DIR_CN%

:: Pack diffs
cd "%RESOURCES_DIR_CN%\resource\char\player\archer\parts"
xcopy * "%TMP_DIR%\"
cd "%TMP_DIR%"
%PAKPACK_EXE% tmp.pak .
move tmp.pak "%MODS_DIR%\Resource00-cn-archer-parts.pak"
del /Q /F *

cd "%RESOURCES_DIR_CN%\resource\char\player\cleric\parts"
xcopy * "%TMP_DIR%\"
cd "%TMP_DIR%"
%PAKPACK_EXE% tmp.pak .
move tmp.pak "%MODS_DIR%\Resource00-cn-cleric-parts.pak"
del /Q /F *

cd "%RESOURCES_DIR_CN%\resource\char\player\soceress\parts"
xcopy * "%TMP_DIR%\"
cd "%TMP_DIR%"
%PAKPACK_EXE% tmp.pak .
move tmp.pak "%MODS_DIR%\Resource00-cn-soceress-parts.pak"
del /Q /F *

cd "%RESOURCES_DIR_CN%\resource\char\player\warrior\parts"
xcopy * "%TMP_DIR%\"
cd "%TMP_DIR%"
%PAKPACK_EXE% tmp.pak .
move tmp.pak "%MODS_DIR%\Resource00-cn-warrior-parts.pak"
del /Q /F *

cd "%RESOURCES_DIR_CN%\resource\item\cash_item"
xcopy * "%TMP_DIR%\"
cd "%TMP_DIR%"
%PAKPACK_EXE% tmp.pak .
move tmp.pak "%MODS_DIR%\Resource00-cn-cash.pak"
del /Q /F *

mkdir "%RESOURCES_DIR_CN%\resource\weapon2"
for %%f in ("%RESOURCES_DIR_CN%\resource\weapon\ac_*") do (
	move "%%f" "%RESOURCES_DIR_CN%\resource\weapon2\"
)

cd "%RESOURCES_DIR_CN%\resource\weapon"
xcopy * "%TMP_DIR%\"
cd "%TMP_DIR%"
%PAKPACK_EXE% tmp.pak .
move tmp.pak "%MODS_DIR%\Resource00-cn-weapons.pak"
del /Q /F *

cd "%RESOURCES_DIR_CN%\resource\weapon2"
xcopy * "%TMP_DIR%\"
cd "%TMP_DIR%"
%PAKPACK_EXE% tmp.pak .
move tmp.pak "%MODS_DIR%\Resource00-cn-weapons2.pak"
del /Q /F *

cd %ROOT_DIR%