import java.io.File;

/**
 * Copyright (C) 2011 Keripo
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author Keripo
 * @version 2011/09/02
 */

public class DNCostumeFilterer {
	
	private static String BASE_DIR = null;
	private static String FILT_DIR = null;
	
	private static void check(File f) {
		if (f.exists() && f.canRead()) {
			if (f.isDirectory()) {
				for (File file : f.listFiles()) {
					check(file);
				}
			} else {
				try {
					File check_file = new File(f.getAbsolutePath().replace(BASE_DIR, FILT_DIR));
					if (check_file.exists() && check_file.canWrite()) {
						check_file.delete();
						System.out.println("Deleted file: " + check_file.getName());
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	private static void print_usage() {
		String program = new DNCostumeFilterer().getClass().getName();
		System.out.println(
				"=====================================================\n" +
				"Dragon Nest Batch Costume Filterer v1\n" +
				"\n" +
				"Usage:\n" +
				"\tjava -jar " + program + " <base_dir> <filter_dir>\n" +
				"\n" +
				"For example:\n" +
				"\tjava -jar " +
						program +
						" \"C:\\Nexon\\DragonNest-NA\\dn-costumes-tools\\Resource\\\"" +
						" \"C:\\Nexon\\DragonNest-NA\\dn-costumes-tools\\Resource-CN\\\"" +
						"\n" +
				"\n" +
				"~Keripo\n" +
				"====================================================="
				);
		System.exit(1);
	}
	
	private static void print_started() {
		System.out.println(
				"=====================================================\n" +
				"Dragon Nest Batch Costume Diff v1\n" +
				"Last updated: 2011/08/31\n" +
				"~Keripo\n" +
				"\n" +
				"<orig_dir> = " + BASE_DIR + "\n" +
				"<filter_dir> = " + FILT_DIR + "\n" +
				"====================================================="
				);				
	}
	
	private static void print_finished() {
		System.out.println(
				"=====================================================\n" +
				"Filtered: " + FILT_DIR + "\n" +
				"with: " + BASE_DIR + "\n" +
				"\n" +
				"Happy modding!\n" +
				"\n" +
				"~Keripo\n" +
				"====================================================="
				);
	}
	
	public static void main(String[] args) {
		
		// Args
		if (args.length != 2) {
			print_usage();
		} else {
			BASE_DIR = args[0];
			FILT_DIR = args[1];
			print_started();
		}
		
		// Search and rename
		File src_dir = new File(BASE_DIR);
		check(src_dir);
		
		// Done
		print_finished();
	}

}
